package com.usky.fire.controller.web;


import com.usky.common.core.bean.ApiResult;
import com.usky.common.core.bean.CommonPage;
import com.usky.fire.service.AlarmFireService;
import com.usky.fire.service.vo.AlarmFireVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 事件管理-火警告警处置
 *
 * @author JCB
 * @since 2022-07-29
 */
@RestController
@RequestMapping("/fireAlarm")
public class AlarmFireController {

    @Autowired
    private AlarmFireService alarmFireService;

    @GetMapping("alarmFireLowerList")
    public ApiResult<CommonPage<AlarmFireVo>> alarmFireLowerList(@RequestParam(value = "handlingStatus", required = false) Integer handlingStatus,
                                                                 @RequestParam(value = "startDate", required = false) String startDate,
                                                                 @RequestParam(value = "endDate", required = false) String endDate,
                                                                 @RequestParam(value = "pageNum", required = false, defaultValue = "1") Integer pageNum,
                                                                 @RequestParam(value = "pageSize", required = false, defaultValue = "10") Integer pageSize) {
        return ApiResult.success(alarmFireService.alarmFireLowerList(handlingStatus,startDate,endDate,pageNum,pageSize));
    }

}

