package com.usky.fire.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.common.core.bean.CommonPage;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.common.security.utils.SecurityUtils;
import com.usky.fire.domain.AlarmFire;
import com.usky.fire.mapper.AlarmFireMapper;
import com.usky.fire.service.AlarmFireService;
import com.usky.fire.service.util.OnlineMethod;
import com.usky.fire.service.vo.AlarmFireVo;
import com.usky.system.model.LoginUser;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 火灾报警系统报警信息表 服务实现类
 * </p>
 *
 * @author JCB
 * @since 2022-07-29
 */
@Service
public class AlarmFireServiceImpl extends AbstractCrudService<AlarmFireMapper, AlarmFire> implements AlarmFireService {

    public CommonPage<AlarmFireVo> alarmFireLowerList(Integer handlingStatus, String startDate, String endDate, Integer pageNum, Integer pageSize) {
        String userType = null;
        LoginUser loginUser = SecurityUtils.getLoginUser();
        if (loginUser != null && !"".equals(loginUser)) {
            userType = loginUser.getUserType();
        }
        //缺少维保单位部分代码
        List<String> devcieCodeList = new ArrayList<>();
        CommonPage<AlarmFire> alarmFireList = this.alarmFireList(devcieCodeList, handlingStatus, startDate, endDate, pageNum, pageSize);
        List<AlarmFireVo> list = new ArrayList<>();
        for (int i = 0; i < alarmFireList.getRecords().size(); i++) {
            AlarmFireVo alarmFireVo = new AlarmFireVo();
            alarmFireVo.setId(alarmFireList.getRecords().get(i).getId());
            alarmFireVo.setAlarmType(alarmFireList.getRecords().get(i).getAlarmType());
            alarmFireVo.setAlarmTime(alarmFireList.getRecords().get(i).getAlarmTime());
            alarmFireVo.setAddress(alarmFireList.getRecords().get(i).getAddress());
            alarmFireVo.setAlarmStatus(alarmFireList.getRecords().get(i).getAlarmStatus());
            alarmFireVo.setOriginalType(alarmFireList.getRecords().get(i).getOriginalType());
            alarmFireVo.setAlarmName(alarmFireList.getRecords().get(i).getAlarmName());
            alarmFireVo.setOriginalPoint(alarmFireList.getRecords().get(i).getOriginalPoint());
            alarmFireVo.setPointType(alarmFireList.getRecords().get(i).getPointType());
            alarmFireVo.setPointDescribe(alarmFireList.getRecords().get(i).getPointDescribe());
            alarmFireVo.setPortNum(alarmFireList.getRecords().get(i).getPortNum());
            alarmFireVo.setHostNum(alarmFireList.getRecords().get(i).getHostNum());
            alarmFireVo.setLoopNum(alarmFireList.getRecords().get(i).getLoopNum());
            alarmFireVo.setPtNum(alarmFireList.getRecords().get(i).getPtNum());
            alarmFireVo.setHandler(alarmFireList.getRecords().get(i).getHandler());
            alarmFireVo.setHandlingTime(alarmFireList.getRecords().get(i).getHandlingTime());
            alarmFireVo.setHandlingContent(alarmFireList.getRecords().get(i).getHandlingContent());
            alarmFireVo.setHandlerPhone(alarmFireList.getRecords().get(i).getHandlerPhone());
            alarmFireVo.setHandlingStatus(alarmFireList.getRecords().get(i).getHandlingStatus());
            alarmFireVo.setFalseAlarm(alarmFireList.getRecords().get(i).getFalseAlarm());
            alarmFireVo.setSitePhoto(alarmFireList.getRecords().get(i).getSitePhoto());
            alarmFireVo.setCompanyName("未定义单位表");
            list.add(alarmFireVo);
        }
        return new CommonPage<>(list, alarmFireList.getTotal(), alarmFireList.getSize(), alarmFireList.getSize());
    }

    @Override
    public CommonPage<AlarmFire> alarmFireList(List<String> deviceCodeList, Integer handlingStatus, String startDate, String endDate, Integer pageNum, Integer pageSize) {
        LambdaQueryWrapper<AlarmFire> queryWrapper = Wrappers.lambdaQuery();
        if (deviceCodeList.size() > 0) {
            queryWrapper.in(AlarmFire::getDeviceCode, deviceCodeList);
        }
        if (handlingStatus != null) {
            queryWrapper.eq(AlarmFire::getHandlingStatus, handlingStatus);
        }

        if (startDate != null && !"".equals(startDate) && endDate != null && !"".equals(endDate)) {
            queryWrapper.between(AlarmFire::getAlarmTime, startDate, endDate);
        }
        int total = this.count(queryWrapper);
        queryWrapper.orderByDesc(AlarmFire::getId);
        if (pageNum != null && pageNum != 0 && pageSize != null && pageSize != 0) {
            Integer startFate = OnlineMethod.getStartFate(pageNum, pageSize);
            queryWrapper.last("limit " + startFate + ","+pageSize);
        }
        List<AlarmFire> list = this.list(queryWrapper);
        return new CommonPage<>(list, total, pageSize, pageNum);
    }
}
